# Command(s) to open the menu, use multiple commands by seperating with ';'
# Usage !playtime or !playtime <mapname>

playtime_commands = "!playtime;!mapplaytime"






import es
import popuplib
import gamethread
import cmdlib
import cPickle
import time
import os
from operator import itemgetter

nospam = {}
data = {}
temp = {}
currentMap = str(es.ServerVar('eventscripts_currentmap'))

sortedlist = None

dictPath = os.path.join(es.getAddonPath('mapplaytime'), "data.db")
if os.path.isfile(dictPath):
    fileStream = open(dictPath, 'rb')
    data = cPickle.load(fileStream)
    fileStream.close()

def load():
    for cmds in str(playtime_commands).strip().split(';'):
        cmdlib.registerSayCommand(cmds, mapPlaytimeCommand, "....")
    checkMapLoop()

def unload():
    for cmds in str(playtime_commands).strip().split(';'):
        cmdlib.unregisterSayCommand(cmds)
    gamethread.cancelDelayed('check_map_loop')
    global currentMap
    now = time.time()
    if str(currentMap) not in data:
        data[str(currentMap)] = {}
        data[str(currentMap)]['time'] = now - temp[str(currentMap)]
        data[str(currentMap)]['played'] = 1
    else:
        data[str(currentMap)]['time'] += now - temp[str(currentMap)]
    savedatabase()

def es_map_start(ev):
    global sortedlist
    sortedlist = sortedplaytime()
    savedatabase()
    nospam.clear()

def savedatabase():
    fileStream = open(dictPath, 'wb')
    cPickle.dump(data, fileStream)
    fileStream.close()

def mapPlaytimeCommand(userid, args):
    global sortedlist
    now = time.time()
    if now - nospam.get(userid, 0) >= 1:
        nospam[userid] = now
        if not args:
            menu = popuplib.easymenu('playtime_menu', None, mapsSelect)
            menu.settitle('Map - Playtime (Times played):')
            if not sortedlist:
                sortedlist = sortedplaytime()
            if sortedlist:
                for map in sortedlist:
                    menu.addoption(map[0], '%s - %s (%s)'%(map[0], formatTime(data[map[0]]['time']), data[map[0]]['played']))
            menu.send(userid)
            menu.delete()
        else:
            mapname = str(args)
            if mapname in data:
                mapStats(userid, mapname)
            else:
                return es.tell(userid, '#multi', '#greenThis map has no records yet.')
                
    else:
        es.tell(userid, '#multi', '#greenPlease don\'t spam.')

def mapsSelect(userid, choice, popupid):
    mapStats(userid, choice)

def mapStats(userid, mapname):
    tr = str(1 + sortedplaytime().index((mapname, data[mapname]['time'])))
    pr = str(1 + sortedtimesplayed().index((mapname, data[mapname]['played'])))
    menu = popuplib.create('playtime_map_menu')
    menu.addline('Stats for %s:'%str(mapname).upper())
    menu.addline(' ')
    menu.addline('Playtime: %s (Ranked #%s)'%(formatTime(data[mapname]['time']), tr))
    menu.addline('Times played: %s (Ranked #%s)'%(data[mapname]['played'], pr))
    menu.addline(' ')
    menu.addline('->8. Back')
    menu.addline('0. Close')
    menu.send(userid)
    menu.delete()
    menu.menuselect = mapStatsSelect

def mapStatsSelect(userid, choice, popupid):
    if choice == 8:
        mapPlaytimeCommand(userid, None)

def map_change():
    global currentMap
    now = time.time()
    if str(currentMap) not in data:
        data[str(currentMap)] = {}
        data[str(currentMap)]['time'] = now - temp[str(currentMap)]
        data[str(currentMap)]['played'] = 1
    else:
        data[str(currentMap)]['time'] += now - temp[str(currentMap)]
        data[str(currentMap)]['played'] += 1
    del temp[str(currentMap)]
    currentMap = str(es.ServerVar('eventscripts_currentmap'))

def checkMapLoop():
    global currentMap
    if str(currentMap) not in temp:
        temp[str(currentMap)] = time.time()
    if str(currentMap) != str(es.ServerVar('eventscripts_currentmap')):
        map_change()
    gamethread.delayedname(1, 'check_map_loop', checkMapLoop)

def formatTime(seconds):
    hours, minutes   = divmod(seconds, 3600)
    minutes, seconds = divmod(minutes, 60)
    return "%s:%02i:%02i" % (int(hours), minutes, seconds)

def sortedplaytime():
    psort = {}
    for map in data:
        psort[map] = data[map]['time']
    return sorted(psort.items(), key=itemgetter(1), reverse=True)

def sortedtimesplayed():
    psort = {}
    for map in data:
        psort[map] = data[map]['played']
    return sorted(psort.items(), key=itemgetter(1), reverse=True)